package demo;

import java.io.*;

//Author: HAU/NIR
public class SerializationDemoApp
{
	public void run() throws Exception
	{
		Person[] persons = new Person[2];
		persons[0] = new Person("Niels");
		persons[1] = new Person("Caroline");
		// === save
		serialize(persons, "persons.dat");
		// === clear the list
		persons = null;
		// === now restore from file - we need a cast here, serialization deals with Object
		persons = (Person[]) deserialize("persons.dat");
		// === Show result to the amazed students
		System.out.println("Array loaded from file:");
		for (Person p:persons)
			System.out.println(p.getName());
	}

	public void serialize(Object o, String fileName) 
	{
		FileOutputStream file=null;
		ObjectOutputStream out=null;
		try
		{
			file = new FileOutputStream(fileName);
			out = new ObjectOutputStream(file);
			out.writeObject(o);
			out.close();
		} catch (FileNotFoundException e)
		{
			System.out.println(e.getMessage());
		}
		 catch (IOException e)
		{
			e.printStackTrace();
		}
		
		
	}

	public Object deserialize(String fileName) throws Exception
	{
		FileInputStream file = new FileInputStream(fileName);
		// === ObjectInPutStream: give us the opportunity to use readObject()
		ObjectInputStream inStream = new ObjectInputStream(file);
		Object o = inStream.readObject();
		inStream.close();
		return o;
	}

	public static void main(String[] args) throws Exception
	{
		SerializationDemoApp sda = new SerializationDemoApp();
		sda.run();
	}
}
