package phonebook;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.Dimension;
import javax.swing.JLabel;
import java.awt.Rectangle;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class PhoneBookFrame extends JFrame
{

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel nameLabel = null;
	private JLabel phoneLabel = null;
	private JTextField nameField = null;
	private JTextField phoneField = null;
	private JButton addButton = null;
	private JButton searchButton = null;
	private JButton countButton = null;
	private JLabel statusLabel = null;
	private PhoneBookController pBController;
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	/**
	 * This is the default constructor
	 */
	public PhoneBookFrame()
	{
		super();
		pBController=new PhoneBookController();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize()
	{
		this.setSize(717, 247);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane()
	{
		if (jContentPane == null)
		{
			statusLabel = new JLabel();
			statusLabel.setBounds(new Rectangle(9, 176, 341, 27));
			statusLabel.setText("");
			phoneLabel = new JLabel();
			phoneLabel.setBounds(new Rectangle(8, 36, 100, 26));
			phoneLabel.setText("Phone number");
			nameLabel = new JLabel();
			nameLabel.setBounds(new Rectangle(8, 6, 98, 26));
			nameLabel.setText("Name");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(nameLabel, null);
			jContentPane.add(phoneLabel, null);
			jContentPane.add(getNameField(), null);
			jContentPane.add(getPhoneField(), null);
			jContentPane.add(getAddButton(), null);
			jContentPane.add(getSearchButton(), null);
			jContentPane.add(getCountButton(), null);
			jContentPane.add(statusLabel, null);
			jContentPane.add(getJScrollPane(), null);
			
		}
		return jContentPane;
	}

	/**
	 * This method initializes nameField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNameField()
	{
		if (nameField == null)
		{
			nameField = new JTextField();
			nameField.setBounds(new Rectangle(114, 6, 234, 26));
		}
		return nameField;
	}

	/**
	 * This method initializes phoneField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPhoneField()
	{
		if (phoneField == null)
		{
			phoneField = new JTextField();
			phoneField.setBounds(new Rectangle(114, 36, 234, 26));
		}
		return phoneField;
	}

	/**
	 * This method initializes addButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAddButton()
	{
		if (addButton == null)
		{
			addButton = new JButton();
			addButton.setBounds(new Rectangle(114, 73, 74, 23));
			addButton.setText("Insert");
			addButton.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
				    String navn = nameField.getText();
				    int tlfNr = Integer.parseInt(phoneField.getText());
				    pBController.insertPerson(navn, tlfNr);
				    statusLabel.setText("New person added");				}
			});
		}
		return addButton;
	}

	/**
	 * This method initializes searchButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSearchButton()
	{
		if (searchButton == null)
		{
			searchButton = new JButton();
			searchButton.setBounds(new Rectangle(226, 73, 121, 23));
			searchButton.setText("Find number");
			searchButton.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
				    String navn = nameField.getText();
				    int nr = pBController.findPhoneForName(navn);
				    if (nr >=0)
				    	statusLabel.setText(navn+" has phoneNumber: " + nr);
				    else
				    { 
				    	statusLabel.setText("No registration for "+navn);
				    }
				    nameField.setText("");				}
			});
		}
		return searchButton;
	}

	/**
	 * This method initializes countButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCountButton()
	{
		if (countButton == null)
		{
			countButton = new JButton();
			countButton.setBounds(new Rectangle(114, 106, 74, 23));
			countButton.setText("Count");
			countButton.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					statusLabel.setText("There are " + pBController.countPersons() + 
							" person(s) in the phonebook.");				}
			});
		}
		return countButton;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane()
	{
		if (jScrollPane == null)
		{
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new Rectangle(387, 9, 277, 139));
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea()
	{
		if (jTextArea == null)
		{
			jTextArea = new JTextArea();
		}
		return jTextArea;
	}

}  //  @jve:decl-index=0:visual-constraint="41,10"
